package _VisualDVM.Passes.All;
import Common.Passes.PassException;
import _VisualDVM.Global;
import _VisualDVM.GlobalData.RemoteFile.RemoteFile;
import _VisualDVM.Passes.PassCode;
import _VisualDVM.Passes.SSH.RepositoryServerSSHPass;

import java.io.File;
public class PublishTestingServer extends RepositoryServerSSHPass {
    @Override
    protected String getServerFileName() {
        return "TestingSystem.jar";
    }
    @Override
    protected String getServerHomeName() {
        return "_testing_system";
    }
    @Override
    public String getIconPath() {
        return "/icons/Publish.png";
    }
    //1. остановить сервер.
    //2. заменить файл сервера на компонент визуализатора. переименовать его.
    //3. запустить сервер.
    @Override
    protected void ServerAction() throws Exception {
        if (Global.mainModule.getPass(PassCode.PingTestingServer).Do(true))
            ShutdownServer();
        if (Global.mainModule.getPass(PassCode.PingTestingServer).Do(true)) {
            throw new PassException("Не удалось остановить сервер.");
        }
        File src = Global.visualiser.getFile();
        //-
        RemoteFile dst = new RemoteFile(serverHome, getServerFileName());
        user.connection.tryRM(dst);
        user.connection.putSingleFile(src, dst);
        //-
        StartServer();
    }
    @Override
    protected boolean validate() {
        if (!Global.mainModule.getPass(PassCode.PingTestingServer).Do(true)) {
            Log.Writeln_("Не удалось запустить сервер.");
        }
        return true;
    }
}
